mkfs: avoid blockdev failing to re-read partition table
[grml-debootstrap.git] / grml-debootstrap
1 #!/bin/bash
2 # Filename:      grml-debootstrap
3 # Purpose:       wrapper around debootstrap for installing plain Debian via Grml
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see https://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2+
7 ################################################################################
8 # shellcheck disable=SC2001,SC2181
9
10 # error_handler {{{
11 error_handler() {
12    last_exit_code="$?"
13    last_bash_command="$BASH_COMMAND"
14    echo "Unexpected non-zero exit code $last_exit_code in ${BASH_SOURCE[*]} at line ${BASH_LINENO[*]} detected!
15 last bash command: $last_bash_command"
16    if [ -r "$MNTPOINT/debootstrap/debootstrap.log" ] && \
17           [ -s "$MNTPOINT/debootstrap/debootstrap.log" ] ; then
18        einfo "Presenting last ten lines of debootstrap.log:"
19        tail -10 "${MNTPOINT}"/debootstrap/debootstrap.log
20        einfo "End of debootstrap.log"
21    fi
22    ## Check if "bailout" function is available.
23    ## This is not the case in chroot-script.
24    if command -v bailout >/dev/null 2>&1; then
25       bailout 1
26    else
27       exit 1
28    fi
29 }
30
31 set -e
32 set -E
33 set -o pipefail
34 trap "error_handler" ERR
35 export -f "error_handler"
36 # }}}
37
38 # variables {{{
39 PN="$(basename "$0")"
40 if [[ -d "$(dirname "$(command -v "$0")")"/.git ]]; then
41   VERSION="$(git --git-dir "$(dirname "$(command -v "$0")")"/.git describe | sed 's|^v||')"
42 else
43   VERSION="$(dpkg-query --show --showformat='${Version}' "$PN")"
44 fi
45 VERSION="${VERSION:-unknown}"
46 MNTPOINT="/mnt/debootstrap.$$"
47
48 # defaults
49 [ -n "$CHROOT_SCRIPTS" ] || CHROOT_SCRIPTS='yes'
50 [ -n "$CONFFILES" ] || CONFFILES='/etc/debootstrap'
51 [ -n "$DEBCONF" ] || DEBCONF='yes'
52 [ -n "$DEBIAN_FRONTEND" ] || DEBIAN_FRONTEND='noninteractive'
53 [ -n "$DEBOOTSTRAP" ] || DEBOOTSTRAP='debootstrap'
54 [ -n "$DEFAULT_LANGUAGE" ] || DEFAULT_LANGUAGE='en_US:en'
55 [ -n "$DEFAULT_LOCALES" ] || DEFAULT_LOCALES='en_US.UTF-8'
56 [ -n "$DISK_IDENTIFIER" ] || DISK_IDENTIFIER='26ada0c0-1165-4098-884d-aafd2220c2c6'
57 [ -n "$EXTRAPACKAGES" ] || EXTRAPACKAGES='yes'
58 [ -n "$FALLBACK_MIRROR" ] || FALLBACK_MIRROR='http://deb.debian.org/debian'
59 [ -n "$FIXED_DISK_IDENTIFIERS" ] || FIXED_DISK_IDENTIFIERS="no"
60 [ -n "$FORCE" ] || FORCE=''
61 [ -n "$HOSTNAME" ] || HOSTNAME='grml'
62 [ -n "$INITRD" ] || INITRD='yes'
63 [ -n "$INITRD_GENERATOR" ] || INITRD_GENERATOR='initramfs-tools'
64 [ -n "$INITRD_GENERATOR_OPTS" ] || INITRD_GENERATOR_OPTS=''
65 [ -n "$INSTALL_NOTES" ] || INSTALL_NOTES='/etc/debootstrap/install_notes'
66 [ -n "$LOCALES" ] || LOCALES='yes'
67 [ -n "$MIRROR" ] || MIRROR="$FALLBACK_MIRROR"
68 [ -n "$MKFS" ] || MKFS='mkfs.ext4'
69 [ -n "$MKFS_OPTS" ] || MKFS_OPTS=''
70 [ -n "$PACKAGES" ] || PACKAGES='yes'
71 [ -n "$POST_SCRIPTS" ] || POST_SCRIPTS='yes'
72 [ -n "$PRE_SCRIPTS" ] || PRE_SCRIPTS='yes'
73 [ -n "$RECONFIGURE" ] || RECONFIGURE='console-data'
74 [ -n "$RELEASE" ] || RELEASE='bookworm'
75 [ -n "$RM_APTCACHE" ] || RM_APTCACHE='yes'
76 [ -n "$SCRIPTS" ] || SCRIPTS='no' # deprecated, replaced by POST_SCRIPTS
77 [ -n "$SECURE" ] || SECURE='yes'
78 [ -n "$TIMEZONE" ] || TIMEZONE='Europe/Vienna'
79 [ -n "$TUNE2FS" ] || TUNE2FS='tune2fs -c0 -i0'
80 [ -n "$UPGRADE_SYSTEM" ] || UPGRADE_SYSTEM='yes'
81 [ -n "$VMSIZE" ] || VMSIZE="2G"
82 [ -n "$GRUB_INSTALL" ] || GRUB_INSTALL='yes'
83
84 # inside the chroot system locales might not be available, so use minimum:
85 export LANG=C
86 export LC_ALL=C
87 export LANGUAGE=C
88
89 # make sure interactive mode is only executed when
90 # using an empty configuration file or option --interactive
91 INTERACTIVE=''
92 # }}}
93
94 # help text {{{
95 usage() {
96   echo "$PN - wrapper around debootstrap for installing Debian
97
98 Usage: $PN [options]
99
100 Bootstrap options:
101
102   -m, --mirror <URL>     Mirror which should be used for apt-get/aptitude.
103   -i, --iso <mnt>        Mountpoint where a Debian ISO is mounted to, for use
104                          instead of fetching packages from a mirror.
105   -r, --release <name>   Release of new Debian system (default: bullseye).
106   -t, --target <target>  Target partition (/dev/...) or directory where the
107                          system should be installed to.
108   -p, --mntpoint <mnt>   Mountpoint used for mounting the target system,
109                          has no effect if -t is given and represents a directory.
110       --debopt <params>  Extra parameters passed to the debootstrap command.
111       --interactive      Use interactive mode (frontend).
112       --nodebootstrap    Skip debootstrap, only do configuration to the target.
113       --grub <device>    Target for grub installation. Usage example: /dev/sda
114       --efi <device>     Target for EFI installation. Usage example: /dev/sda1
115       --arch <arch>      Set target architecture, use for installing i386 on amd64.
116       --filesystem <fs>  Filesystem that should be used when target is a partition
117                          or Virtual Machine (see --vmfile).
118       --force            Do not prompt for user acknowledgement.
119
120 Options for Virtual Machine deployment:
121
122       --vm               Set up a Virtual Machine on an existing block device
123                          instead of plainly installing to a partition or
124                          directory. Needs to be combined with --target.
125                          Example: --vm --target /dev/mapper/your-vm-disk
126       --vmfile           Like --vm, but install into a regular file (created by
127                          'qemu-img create -f raw ...') instead.
128                          Example: --vmfile --target /mnt/sda1/qemu.img
129       --vmsize <size>    Use specified size for size of VM file (default: 2G).
130                          Syntax as supported by qemu-img, like: --vmsize 3G
131       --vmefi            Create an EFI boot partition for the VM.
132
133 Configuration options:
134
135   -c, --config <file>      Use specified configuration file, defaults to
136                              /etc/debootstrap/config
137   -d, --confdir <path>     Place of config files for debootstrap, defaults
138                              to /etc/debootstrap
139       --packages <file>    Install packages defined in specified list file
140                              instead of using /etc/debootstrap/packages.
141       --nopackages         Skip installation of packages defined in
142                              /etc/debootstrap/packages
143       --nokernel           Skip installation of default kernel images.
144       --nointerfaces       Do not copy /etc/network/interfaces from host system
145                            to target system.
146                            (This option is automatically enabled when using --vmfile.)
147       --defaultinterfaces  Install a default /etc/network/interfaces file (enabling
148                            DHCP for eth0) instead of taking over config from host system.
149       --debconf <file>     Pre-seed packages using specified pre-seed db file.
150       --grmlrepos          Enable Grml's Debian repository (deb.grml.org).
151       --backportrepos      Enable Debian's backports repository (backports.debian.org).
152       --keep_src_list      Do not overwrite user provided apt sources.list.
153       --contrib            Enable 'contrib' in COMPONENTS (defaults to 'main' only).
154       --non-free           Enable non-free / non-free-firmware in COMPONENTS (defaults to 'main' only).
155       --hostname <name>    Hostname of Debian system.
156       --nopassword         Do not prompt for the root password.
157       --password <pwd>     Use specified password as password for user root.
158       --sshcopyauth        Use ${HOME}/.ssh/authorized_keys to authorise root login on the target system.
159       --sshcopyid          Use locally available public keys to authorise root login on the target system.
160       --bootappend <line>  Add specified appendline to kernel whilst booting.
161       --chroot-scripts <d> Execute chroot scripts from specified directory.
162       --pre-scripts <dir>  Execute scripts from specified directory (before chroot-scripts).
163       --scripts <dir>      Execute scripts from specified directory (after chroot-scripts).
164       --remove-configs     Delete grml-debootstrap configuration files from installed system.
165
166 Other options:
167
168   -v, --verbose            Increase verbosity.
169       --debug              Execute in very verbose way.
170   -h, --help               Print this usage information and exit.
171   -V, --version            Show summary of options and exit.
172
173 Usage examples can be found in the grml-debootstrap manpage.
174 Send bugreports to the grml-team: bugs (at) grml.org || https://grml.org/bugs/
175 "
176 }
177
178 if [ "$1" = '-h' ] || [ "$1" = '-help' ] || [ "$1" = "--help" ] ; then
179    usage
180    echo 'Please notice that this script requires root permissions!'
181    exit 0
182 fi
183 # }}}
184
185 # early helper functions {{{
186 # skip colors when running within a dumb terminal
187 if [ "${TERM}" = "dumb" ] ; then
188   GOOD=
189   BAD=
190   WARN=
191   NORMAL=
192 else
193   GOOD='\e[32;01m'
194   BAD='\e[31;01m'
195   WARN='\e[33;01m'
196   NORMAL='\e[0m'
197 fi
198
199 einfo() {
200   einfon "$1\\n"
201   return 0
202 }
203
204 einfon() {
205   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
206   printf " %s*%s $*" "${GOOD}" "${NORMAL}"
207   LAST_E_CMD=einfon
208   return 0
209 }
210
211 ewarn() {
212   printf " %s*%s $*\\n" "${WARN}" "${NORMAL}"
213   return 0
214 }
215
216 eerror() {
217   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
218   printf " %s*%s $*\\n" "${BAD}" "${NORMAL}" >&2
219   LAST_E_CMD=eerror
220   return 0
221 }
222
223 eend() {
224   local retval="${1:-0}"
225   shift
226   if [ "$retval" -gt 0 ]; then
227     printf " %s-> Failed (rc=%s)%s\\n" "${BAD}" "${retval}" "${NORMAL}"
228   fi
229   return "$retval"
230 }
231
232 check4root(){
233   if [ "$(id -u 2>/dev/null)" != 0 ] ; then
234     echo 1>&2 "Error: please run this script with uid 0 (root)." ; return 1
235   fi
236 }
237
238 check4progs(){
239   local RC=''
240   for arg in "$@" ; do
241     command -v "$arg" >/dev/null 2>&1 || RC="$arg"
242   done
243   if [ -n "$RC" ] ; then
244      echo "$RC not installed"
245      return 1
246   fi
247 }
248 # }}}
249
250 # unmount mountpoint {{{
251 try_umount() {
252   local tries=$1
253   local mountpoint="$2"
254
255   if ! mountpoint "$mountpoint" &>/dev/null ; then
256     return 0
257   fi
258
259   for (( try=1; try<=tries; try++ )); do
260     if [[ ${try} -eq ${tries} ]]; then
261       # Last time, show errors this time
262       umount "${mountpoint}" && return 0
263     else
264       # Not last time, hide errors until fatal
265       if umount "${mountpoint}" 2>/dev/null ; then
266         return 0
267       else
268         sleep 1
269       fi
270     fi
271   done
272   return 1  # Tried enough
273 }
274 # }}}
275
276 # helper functions {{{
277 cleanup() {
278   if [ -n "$CHROOT_VARIABLES" ] ; then
279     einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" || eend $?
280   fi
281
282   if [ -n "$STAGES" ] ; then
283     einfo "Removing ${STAGES}" ; rmdir "$STAGES" || eend $?
284   fi
285
286   try_umount 3 "${MNTPOINT}"/boot/efi
287
288   # Remove temporary mountpoint again
289   if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
290     if [ -d "$MNTPOINT" ] ; then
291       rmdir "$MNTPOINT" || true
292     fi
293   fi
294
295   # make sure $TARGET is not mounted when exiting grml-debootstrap
296   if [ -n "$MNTPOINT" ] ; then
297     if grep -q "$MNTPOINT" /proc/mounts ; then
298       # make sure nothing is left inside chroot so we can unmount it
299       for service in ssh mdadm ; do
300         if [ -x "${MNTPOINT}/etc/init.d/${service}" ] ; then
301           chroot "$MNTPOINT" "/etc/init.d/${service}" stop
302         fi
303       done
304
305       [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a >/dev/null 2>&1 || true
306
307       # ugly, but make sure we really don't leave anything (/proc /proc and
308       # /dev /dev are intended, trying to work around timing issues, see #657023)
309       for ARG in /run/udev /sys /proc /proc /dev/pts /dev/pts /dev /dev ; do
310         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount $ARG >/dev/null 2>&1 || true
311         umount "$MNTPOINT"/$ARG >/dev/null 2>&1 || true
312       done
313
314       if [ -n "$ISODIR" ] ; then
315         try_umount 3 "$MNTPOINT/$ISODIR" >/dev/null 2>&1 || true
316       fi
317
318       if [ -n "$DIRECTORY" ] ; then
319         einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice."
320       else
321         einfo "Unmounting $MNTPOINT"
322         try_umount 3 "$MNTPOINT"
323       fi
324
325       if [ -n "$STAGES" ] ; then
326         echo -n "Removing stages directory ${STAGES}: "
327         rm -rf "$STAGES" && echo 'done'
328       fi
329
330       # remove directory only if we used the default with process id inside the name
331       if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
332         if [ -d "$MNTPOINT" ] ; then
333           einfo "Removing directory ${MNTPOINT}"
334           rmdir "$MNTPOINT" || eend $?
335         fi
336       fi
337     fi
338   fi
339
340   if [ -n "${ORIG_TARGET}" ] ; then
341     einfo "Removing loopback mount of file ${ORIG_TARGET}."
342     kpartx -d "${ORIG_TARGET}" || eend $?
343     # Workaround for a bug in kpartx which doesn't clean up properly,
344     # see Debian Bug #891077 and Github-PR grml/grml-debootstrap#112
345     if dmsetup ls | grep -q "^${LOOP_PART} "; then
346       kpartx -d "/dev/${LOOP_DISK}" >/dev/null || eend $?
347     fi
348   fi
349 }
350
351 # we want to exit smoothly and clean:
352 bailout(){
353   eend "$1" || true
354
355   cleanup
356
357   [ -n "$1" ] && EXIT="$1" || EXIT="1"
358   [ -n "$2" ] && einfo "Notice: remove $STAGES/$2 to reexecute the stage"
359
360   exit "$EXIT"
361 }
362 trap bailout HUP INT QUIT TERM
363
364 # we want to execute all the functions only once, simple check for it:
365 stage() {
366   if [ -n "$2" ] ; then
367      echo "$2" > "${STAGES}/${1}"
368      return 0
369   elif grep -q 'done' "${STAGES}/${1}" 2>/dev/null ; then
370      ewarn "Notice: stage $1 has been executed already, skipping execution therefore."
371      ewarn "  To reexecute it clean up the according directory inside $STAGES"
372      return 1
373   fi
374 }
375 # }}}
376
377 # source main configuration file {{{
378 if [ -r /etc/debootstrap/config ] ; then
379   bash -n /etc/debootstrap/config
380   # shellcheck disable=SC1091
381   . /etc/debootstrap/config
382 fi
383 # }}}
384
385 # cmdline handling {{{
386 CMDLINE_OPTS=mirror:,iso:,release:,target:,mntpoint:,debopt:,defaultinterfaces,interactive,nodebootstrap,nointerfaces,nokernel,nopackages,filesystem:,config:,confdir:,packages:,chroot-scripts:,scripts:,post-scripts:,pre-scripts:,debconf:,vm,vmfile,vmsize:,vmefi,keep_src_list,hostname:,password:,nopassword,grmlrepos,backportrepos,bootappend:,grub:,efi:,arch:,insecure,verbose,help,version,force,debug,contrib,non-free,remove-configs,sshcopyid,sshcopyauth
387
388 if ! _opt_temp=$(getopt --name grml-debootstrap -o +m:i:r:t:p:c:d:vhV --long \
389   $CMDLINE_OPTS -- "$@"); then
390   eerror "Try 'grml-debootstrap --help' for more information."
391   bailout 1
392 fi
393 eval set -- "$_opt_temp"
394
395 while :; do
396   case "$1" in
397
398   # == Bootstrap options
399   --mirror|-m)         # Mirror which should be used for apt-get/aptitude
400     shift; _opt_mirror="$1"
401     ;;
402   --iso|-i)            # Mountpoint where a Debian ISO is mounted to
403     shift; _opt_iso="$1"
404     ;;
405   --release|-r)        # Release of new Debian system
406     shift; _opt_release="$1"
407     ;;
408   --target|-t)         # Target partition (/dev/...) or directory
409     shift; _opt_target="$1"
410     ;;
411   --vm)                # Virtual machine image (no file)
412     _opt_vm="T"
413     ;;
414   --vmfile)            # Virtual machine file
415     _opt_vmfile="T"
416     ;;
417   --vmsize)            # size of Virtual machine file
418     shift; _opt_vmsize="$1"
419     ;;
420   --vmefi)            # Create an EFI boot partition for the VM
421     _opt_vmefi="T"
422     ;;
423   --mntpoint|-p)       # Mountpoint used for mounting the target system
424     shift; _opt_mntpoint="$1"
425     ;;
426   --debopt)            # Extra parameters passed to the debootstrap command
427     shift; _opt_debopt="$1"
428     ;;
429   --filesystem)        # Filesystem that should be used
430     shift; _opt_filesystem="$1" ; FILESYSTEM="${_opt_filesystem}"
431     ;;
432   --interactive)       # Use interactive mode (frontend)
433     _opt_interactive=T
434     ;;
435   --nodebootstrap)     # Skip debootstrap, only do configuration to the target
436     _opt_nodebootstrap=T
437     ;;
438   --nopackages)        # Skip installation of packages defined in /etc/debootstrap/packages
439     _opt_nopackages=T
440     ;;
441   --arch)              # Target architecutre
442     shift; _opt_arch="$1"
443     ;;
444   # just for backwards compatibility
445   --insecure)
446     _opt_insecure=T
447     ;;
448   #
449
450   # == Configuration options
451   --config|-c)         # Use specified configuration file, defaults to /etc/debootstrap
452     shift; _opt_config="$1"
453     ;;
454   --confdir|-d)        # Place of config files for debootstrap, defaults to /etc/debootstrap
455     shift; _opt_confdir="$1"
456     ;;
457   --packages)          # Install packages defined in specified file
458     shift; _opt_packages="$1"
459     _opt_packages_set=T
460     ;;
461   --debconf)           # Pre-seed packages using specified file
462     shift; _opt_debconf="$1"
463     _opt_debconf_set=T
464     ;;
465   --pre-scripts)       # Execute scripts from specified directory (before chroot-scripts).
466     shift; _opt_pre_scripts="$1"
467     _opt_pre_scripts_set=T
468     ;;
469   --scripts)           # Execute scripts from specified directory [NOTE: deprecated, replaced via --post-scripts]
470     shift; _opt_scripts="$1"
471     _opt_scripts_set=T
472     ;;
473   --post-scripts)       # Execute scripts from specified directory
474     shift; _opt_post_scripts="$1"
475     _opt_post_scripts_set=T
476     ;;
477   --chroot-scripts)   # Execute chroot scripts from specified directory
478     shift; _opt_chroot_scripts="$1"
479     _opt_chroot_scripts_set=T
480     ;;
481   --keep_src_list)     # Do not overwrite user provided apt sources.list
482     _opt_keep_src_list=T
483     ;;
484   --hostname)          # Hostname of Debian system
485     shift; _opt_hostname="$1"
486     ;;
487   --password)          # Use specified password as password for user root
488     shift; _opt_password="$1"
489     ;;
490   --defaultinterfaces) # Install default /etc/network/interfaces
491     _opt_defaultinterfaces=T
492     ;;
493   --nointerfaces)      # Skip installation of /etc/network/interfaces
494     _opt_nointerfaces=T
495     ;;
496   --nokernel)          # Skip installation of default kernel images
497     _opt_nokernel=T
498     ;;
499   --nopassword)        # Skip password dialog
500     _opt_nopassword=T
501     ;;
502   --sshcopyid)         # Use locally available public keys to authorise root login on the target system
503     _opt_sshcopyid=T
504     ;;
505   --sshcopyauth)       # Use .ssh/authorized_keys to authorise root login on the target system
506     _opt_sshcopyauth=T
507     ;;
508   --grmlrepos)         # Enable Grml repository
509     _opt_grmlrepos=T
510     ;;
511   --backportrepos)     # Enable Debian backports repository
512     _opt_backportrepos=T
513     ;;
514   --bootappend)        # Add specified appendline to kernel whilst booting
515     shift; _opt_bootappend="$1"
516     ;;
517   --grub)              # Target for grub installation. Use grub syntax for specifying
518     shift; _opt_grub="$1"
519     ;;
520   --efi)               # Target for EFI boot installation
521     shift; _opt_efi="$1"
522     ;;
523   --contrib)           # Add 'contrib' to list of components
524     _opt_contrib=T
525     ;;
526   --non-free)          # Add 'non-free' to list of components
527     _opt_non_free=T
528     ;;
529   --remove-configs)    # Drop config files from installed system
530     _opt_remove_configs=T
531     ;;
532
533   # == Other options
534   --verbose|-v)        # Increase verbosity
535     if [ "$_opt_verbose" ]; then
536       _opt_verbose=$( _opt_verbose + 1 )
537     else
538       _opt_verbose=1
539     fi
540     ;;
541   --debug)             # Execute in debug mode
542     _opt_debug=T
543     ;;
544   --help|-h)           # Print usage information and exit
545     _opt_help=T
546     ;;
547   --version|-V)        # Show version information and exit
548     _opt_version=T
549     ;;
550   --force)             # Do not prompt for user input
551     _opt_force=T
552     ;;
553   --)
554     shift; break
555     ;;
556   *)
557     eerror "Internal getopt error!"; eend 1 ; exit 1
558     ;;
559   esac
560   shift
561 done
562
563 # == business-logic of command line parameter-processing
564
565 # source configuration file in <confdir> if supplied. {{{
566 [ "$_opt_confdir" ] && {
567   CONFFILES=$_opt_confdir
568   einfo "Using config files under $CONFFILES/."
569   if ! [ -r "$CONFFILES/config" ] ; then
570     eerror "Error: config file $CONFFILES/config not found."; bailout 1
571   fi
572   # shellcheck disable=SC1091 source=config
573   if ! . "$CONFFILES/config" ; then
574     eerror "Error reading config file $CONFFILES/config" ; bailout 1
575   fi
576   # restore the command line parameter value
577   CONFFILES=$_opt_confdir
578 }
579 # }}}
580
581 [ "$_opt_mirror" ]              && MIRROR=$_opt_mirror
582 [ "$_opt_iso" ]                 && ISO=$_opt_iso
583 [ "$_opt_release" ]             && RELEASE=$_opt_release
584 [ "$_opt_target" ]              && TARGET=$_opt_target
585 [ "$_opt_vm" ]                  && VIRTUAL=1
586 [ "$_opt_vmfile" ]              && VMFILE=1 && VIRTUAL=1
587 [ "$_opt_vmsize" ]              && VMSIZE=$_opt_vmsize
588 [ "$_opt_vmefi" ]               && VMEFI=1
589 [ "$_opt_mntpoint" ]            && MNTPOINT=$_opt_mntpoint
590 [ "$_opt_debopt" ]              && DEBOOTSTRAP_OPT=$_opt_debopt
591 [ "$_opt_interactive" ]         && INTERACTIVE=1
592 [ "$_opt_config" ]              && CONFIGFILE=$_opt_config
593 [ "$_opt_filesystem" ]          && MKFS="mkfs.$_opt_filesystem"
594 [ "$_opt_packages_set" ]        && PACKAGES='yes'
595 [ "$_opt_nopackages" ]          && PACKAGES=''
596 [ "$_opt_debconf_set" ]         && DEBCONF='yes'
597 [ "$_opt_post_scripts_set" ]    && POST_SCRIPTS='yes'
598 [ "$_opt_pre_scripts_set" ]     && PRE_SCRIPTS='yes'
599 [ "$_opt_chroot_scripts_set" ]  && CHROOT_SCRIPTS='yes'
600 [ "$_opt_keep_src_list" ]       && KEEP_SRC_LIST='yes'
601 [ "$_opt_grmlrepos" ]           && GRMLREPOS='yes'
602 [ "$_opt_backportrepos" ]       && BACKPORTREPOS='yes'
603 [ "$_opt_hostname" ]            && HOSTNAME=$_opt_hostname
604 [ "$_opt_password" ]            && ROOTPASSWORD=$_opt_password
605 [ "$_opt_nopassword" ]          && NOPASSWORD='yes'
606 [ "$_opt_defaultinterfaces" ]   && USE_DEFAULT_INTERFACES="true"
607 [ "$_opt_nointerfaces" ]        && NOINTERFACES="true"
608 [ "$_opt_nokernel" ]            && NOKERNEL="true"
609 [ "$_opt_sshcopyid" ]           && SSHCOPYID="true"
610 [ "$_opt_sshcopyauth" ]         && SSHCOPYAUTH="true"
611 [ "$_opt_bootappend" ]          && BOOT_APPEND=$_opt_bootappend
612 [ "$_opt_grub" ]                && GRUB=$_opt_grub
613 [ "$_opt_efi" ]                 && EFI=$_opt_efi
614 [ "$_opt_arch" ]                && ARCH=$_opt_arch
615 [ "$_opt_insecure" ]            && echo "Warning: --insecure is deprecated, continuing anyway."
616 [ "$_opt_force" ]               && FORCE=$_opt_force
617 [ "$_opt_verbose" ]             && VERBOSE="-v"
618 [ "$_opt_debug" ]               && DEBUG="true"
619 [ "$_opt_remove_configs" ]      && REMOVE_CONFIGS="yes"
620
621 # make sure main is always included
622 [ -z "$COMPONENTS" ]            && COMPONENTS="main"
623 [ "$_opt_contrib" ]             && COMPONENTS="$COMPONENTS contrib"
624
625 case "${RELEASE}" in
626   jessie|stretch|buster|bullseye)
627     [ "$_opt_non_free" ] && COMPONENTS="$COMPONENTS non-free"
628     ;;
629   *)
630     [ "$_opt_non_free" ] && COMPONENTS="$COMPONENTS non-free-firmware non-free"
631     ;;
632 esac
633
634 # command line option checks
635 if [ "$_opt_scripts_set" ] ; then
636   ewarn "Deprecation NOTE: --scripts option is deprecated, please switch to --post-scripts instead."
637   SCRIPTS='yes' # deprecated since grml-debootstrap >=0.71
638 fi
639
640 if [ "$_opt_grub" ] && [ "$_opt_vmfile" ] ; then
641   eerror "The --grub option is incompatible with --vmfile, please drop it from your command line."
642   eerror "The --grub option is unneeded as GRUB will be installed automatically (unless GRUB_INSTALL='no')."
643   bailout 1
644 fi
645
646 if [ "${_opt_sshcopyid}" ] && [ "${_opt_sshcopyauth}" ] ; then
647   eerror "The --sshcopyid option is incompatible with --sshcopyauth, please drop either of them from your command line."
648   bailout 1
649 fi
650
651 if [ -n "$ISO" ] && [[ "$DEBOOTSTRAP" =~ mmdebstrap$ ]] ; then
652   eerror "The ISO option is incompatible with usage of mmdebstrap for bootstrapping."
653   eerror "Either drop the --iso ... option or use plain debootstrap instead."
654   bailout 1
655 fi
656
657 if [ "$DEBUG" = "true" ] ; then
658   set -x
659 fi
660
661 [ "$_opt_help" ] && {
662   usage
663   exit 0
664 }
665
666 [ "$_opt_version" ] && {
667   einfo "$PN - version $VERSION"
668   einfo "Report bugs via https://github.com/grml/grml-debootstrap/ or https://grml.org/bugs/"
669   exit 0
670 }
671 # }}}
672
673 # check for root permissions {{{
674 if ! check4root ; then
675    echo "For usage instructions please execute '$PN --help'."
676    bailout 1
677 fi
678 # }}}
679
680 # make sure we have what we need {{{
681 check4progs "${DEBOOTSTRAP}" || bailout 1
682
683 if [ -n "$VIRTUAL" ] ; then
684   check4progs kpartx parted qemu-img || bailout 1
685 fi
686 # }}}
687
688 # source specified configuration file {{{
689 if [ -n "$CONFIGFILE" ] ; then
690   einfo "Reading specified config file $CONFIGFILE."
691   bash -n "$CONFIGFILE"
692   # shellcheck disable=SC1091 source=config
693   if ! . "$CONFIGFILE" ; then
694     eerror "Error reading config file $CONFIGFILE" ; bailout 1
695   fi
696 fi
697 # }}}
698
699 # backwards compatibility checks {{{
700 if [ -n "$GROOT" ] ; then
701    eerror "Error: you seem to have \$GROOT configured."
702    eerror "This variable is no longer supported, please visit the"
703    eerror "grml-debootstrap documentation for details."
704    bailout 1
705 fi
706
707 if echo "$GRUB" | grep -q '^hd' ; then
708    eerror "Error: this syntax for the grub configuration variable is no longer supported."
709    eerror "Please do not use hd... any longer but /dev/sdX instead."
710    bailout 1
711 fi
712 # }}}
713
714 # welcome screen {{{
715 welcome_dialog()
716 {
717    dialog --title "$PN" --yesno "Welcome to the interactive configuration of ${PN}.
718 Do you want to continue installing Debian using this frontend?" 0 0 || bailout 0
719 }
720 # }}}
721
722 # ask for target {{{
723 prompt_for_target()
724 {
725   AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
726                sed 's/*//' | \
727                grep -v 'Extended$' | \
728                gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}'; ls /dev/md[0-9]* 2>/dev/null || true);
729
730   if [ -z "$AVAILABLE_PARTITIONS" ] ; then
731      dialog --title "$PN" --trim \
732      --msgbox "Sorry, no partitions found. Please configure your
733      harddisks (see /proc/partitions) using a tool like fdisk,
734      cfdisk, gpart, gparted,..." 0 0 || bailout 1
735   fi
736
737   PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
738                      fs="$(blkid -s TYPE -o value "$i" 2>/dev/null)"
739                      [ -n "$fs" ] || fs='[no_filesystem_yet]'
740                      echo "$i" "$fs"
741                      unset fs
742                    done)
743
744   # shellcheck disable=SC2086
745   TARGET=$(dialog --title "$PN" --single-quoted --stdout \
746          --menu "Please select the target partition:" 0 0 0 \
747          $PARTITION_LIST) || bailout 1
748 }
749 # }}}
750
751 # ask for bootmanager {{{
752 prompt_for_bootmanager()
753 {
754   ADDITIONAL_PARAMS=""
755
756   if echo "$TARGET" | grep -q "/dev/md" ; then
757      MBRPART="all disks of Software RAID $TARGET"
758   else
759      # figure out whole disk device
760      found=
761      for device in /dev/disk/by-id/*
762      do
763         [ "$(readlink -f "$device")" = "${TARGET}" ] || continue
764         found=1
765         break
766      done
767      # shellcheck disable=SC2001
768      [ -n "$found" ] && MBRDISK=$(echo "${device}" | sed -e 's/-part[0-9][0-9]*$//')
769      if [ -e "$MBRDISK" ]; then
770         MBRDISK=$(readlink -f "$MBRDISK")
771      else
772         # fall back to old behaviour
773         # shellcheck disable=SC2001
774         MBRDISK=$(echo "${TARGET}" | sed -e 's/[0-9][0-9]*$//')
775      fi
776
777      MBRPART="MBR of $MBRDISK"
778   fi
779
780   for device in cciss/c0d0 sda hda; do
781     if [ "/dev/$device" != "${MBRDISK}" ]; then
782       grep -q $device /proc/partitions && \
783       ADDITIONAL_PARAMS="$ADDITIONAL_PARAMS:$device:install bootmanager grub into MBR of /dev/$device"
784     fi
785   done
786   ADDITIONAL_PARAMS=${ADDITIONAL_PARAMS#:}
787
788   OIFS="$IFS"; IFS=:
789
790   # shellcheck disable=SC2086
791   GETMBR=$(dialog --stdout --title "$PN" --default-item mbr \
792           --menu "Where do you want to install the bootmanager grub?" 0 0 0 \
793             mbr       "install bootmanager into $MBRPART" \
794             nowhere   "do not install bootmanager at all" \
795           ${ADDITIONAL_PARAMS}) || bailout 3
796   IFS="$OIFS"
797
798   case "$GETMBR" in
799     mbr)
800       # /dev/md0: has to be installed in MBR of /dev/md0 and not in /dev/md:
801       if echo "$TARGET" | grep -q "/dev/md" ; then
802         GRUB="$TARGET"
803       else
804         GRUB="$MBRDISK"
805       fi
806       ;;
807     hda)
808       GRUB="/dev/hda"
809       ;;
810     sda)
811       GRUB="/dev/sda"
812       ;;
813     nowhere)
814       GRUB=''
815       ;;
816   esac
817 }
818 # }}}
819
820 # ask for Debian release {{{
821 prompt_for_release()
822 {
823   [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='bullseye'
824   RELEASE="$(dialog --stdout --title "${PN}" --default-item $DEFAULT_RELEASE --menu \
825             "Please enter the Debian release you would like to use for installation:" \
826             0 50 8 \
827             buster   Debian/10 \
828             bullseye Debian/11 \
829             bookworm Debian/12 \
830             sid      Debian/unstable)" \
831             || bailout
832 }
833 # }}}
834
835 # ask for hostname {{{
836 prompt_for_hostname()
837 {
838   HOSTNAME="$(dialog --stdout --title "${PN}" --inputbox \
839             "Please enter the hostname you would like to use for installation:" \
840             0 0 "$HOSTNAME")" || bailout
841 }
842 # }}}
843
844 # ask for password {{{
845 prompt_for_password()
846 {
847   if [ "$_opt_nopassword" ] ; then
848     einfo "Skip asking for root password as requested."
849     return 0
850   fi
851
852   ROOTPW1='PW1'
853   ROOTPW2='PW2'
854   while [ "$ROOTPW1" != "$ROOTPW2" ]; do
855     ROOTPW1=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
856     "Please enter the password for the root account:" 10 60) || bailout
857
858     ROOTPW2=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
859     "Please enter the password for the root account again for \
860     confirmation:" 10 60) || bailout
861
862     if [ "$ROOTPW1" != "$ROOTPW2" ]; then
863       dialog --stdout --title "${PN}" --ok-label \
864         "Retry" --msgbox "Passwords do not match!" 10 60
865     fi
866   done
867   ROOTPASSWORD="$ROOTPW1"
868 }
869 # }}}
870
871 # ask for Debian mirror {{{
872 prompt_for_mirror()
873 {
874   [ -n "$ISO" ] && DEFAULT_MIRROR='local' || DEFAULT_MIRROR='net'
875
876   CHOOSE_MIRROR=$(dialog --stdout --title "$PN" --default-item $DEFAULT_MIRROR \
877           --menu "Where do you want to install from?" 0 0 0 \
878             net   "install via network (downloading from mirror)" \
879             local "install from local directory/mirror"
880           )
881
882   if [ "$CHOOSE_MIRROR" = 'net' ] ; then
883      [ -n "$MIRROR" ] || MIRROR='http://deb.debian.org/debian'
884      MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
885                "Please enter Debian mirror you would like to use for installing packages." \
886                0 0 $MIRROR)" || bailout
887
888   else # CHOOSE_MIRROR == local
889      [ -n "$ISO" ] || ISO='/mnt/mirror'
890      ISO="$(dialog --stdout --title "${PN}" --inputbox \
891                "Please enter directory name you would like to use for installing packages." \
892                0 0 $ISO)" || bailout
893   fi
894 }
895 # }}}
896
897 # software raid setup {{{
898 config_swraid_setup()
899 {
900 TMPFILE=$(mktemp)
901
902 # Currently we support only raid1:
903 RAIDLEVEL='raid1'
904
905 MD_LIST=$(for i in $(seq 0 9) ; do
906             awk '{print $4}' /proc/partitions | grep -q "md$i" || \
907             echo "/dev/md$i /dev/md$i"
908           done)
909
910 # shellcheck disable=SC2086
911 TARGET=$(dialog --stdout --title "$PN" --default-item /dev/md0 \
912 --menu "Which device do you want to use for ${RAIDLEVEL}?
913
914 Notice: activated devices will not be listed for security reasons. Anyway, please make sure the selected device is not in use already!" 0 0 0 \
915 $MD_LIST) || bailout 20
916
917 AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
918              sed 's/*//' | \
919              grep -v 'Extended$' | \
920              gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
921 [ -n "$AVAILABLE_PARTITIONS" ] || echo "Fatal error: no partitions available?"
922 PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
923                      echo "$i $(blkid -s TYPE -o value "$i" 2>/dev/null || echo '[no_filesystem_yet]') off"
924                  done)
925
926 # shellcheck disable=SC2086
927 dialog --title "$PN" --separate-output \
928        --checklist "Please select the partitions you would like to use for your $RAIDLEVEL on ${TARGET}:" 0 0 0 \
929        $PARTITION_LIST 2>"$TMPFILE" || bailout
930
931 SELECTED_PARTITIONS="$(cat "$TMPFILE")"
932
933 NUM_PARTITIONS=0
934 while IFS= read -r i; do
935   NUM_PARTITIONS=$(( NUM_PARTITIONS + 1 ))
936 done < "$TMPFILE"
937
938 ERRORFILE=$(mktemp)
939
940 local RC=0
941 # shellcheck disable=SC2086
942 yes | mdadm --create "${TARGET}" --level="${RAIDLEVEL}" \
943       --raid-devices="${NUM_PARTITIONS}" ${SELECTED_PARTITIONS} >/dev/null 2>$ERRORFILE || RC=$?
944
945 if [ "$RC" = 0 ] ; then
946    dialog --title "$PN" --msgbox \
947    "Creating $TARGET was successful." 0 0
948    rm -f "$TMPFILE" "$ERRORFILE"
949 else
950    dialog --title "$PN" --msgbox \
951    "There was an error setting up $TARGET:
952
953 $(cat "$ERRORFILE")
954
955 Exiting." 0 0
956    rm -f "$TMPFILE" "$ERRORFILE"
957    bailout 1
958 fi
959
960 }
961
962 prompt_for_swraid()
963 {
964 if dialog --stdout --title "$PN" \
965           --defaultno --yesno "Do you want to configure Software RAID?
966
967 Please notice that only RAID level 1 is supported by ${PN} currently. Configuration will take place using mdadm." 0 0 ; then
968   config_swraid_setup
969 fi
970 }
971 # }}}
972
973 # user should recheck his configuration {{{
974 # support full automatic installation:
975 checkforrun() {
976    dialog --timeout 10 --title "$PN" \
977           --yesno "Do you want to stop at this stage?
978
979 Notice: you are running ${PN} in non-interactive mode.
980 ${PN} will install Debian ${RELEASE} on ${TARGET}.
981 Last chance to quit. Timeout of 10 seconds running....
982
983 Do you want to stop now?" 0 0 2>/dev/null
984 }
985 # }}}
986
987 # format efi partition {{{
988 format_efi_partition() {
989   if [ -z "$EFI" ] ; then
990     return 0
991   fi
992
993   if ! [ -b "$EFI" ] ; then
994     eerror "Specified efi argument [$EFI] not a valid block device."
995     bailout 1
996   fi
997
998   if fsck.vfat -bn "$EFI" >/dev/null; then
999     einfo "EFI partition $EFI seems to have a FAT filesystem, not modifying."
1000   else
1001     einfo "EFI partition $EFI doesn't seem to be formatted, creating filesystem."
1002     if ! mkfs.fat -F32 -n "EFI" "$EFI" ; then
1003       eerror "Error while creating filesystem on ${EFI}."
1004       bailout 1
1005     fi
1006   fi
1007 }
1008 # }}}
1009
1010 # check for EFI support or try to enable it {{{
1011 efi_support() {
1012   local efivars_loaded=false
1013   # this is for kernels versions before v3.10, which didn't provide efivarfs yet
1014   if modprobe efivars &>/dev/null ; then
1015     efivars_loaded=true
1016   fi
1017   # kernel versions v3.10 and newer usually provide efivarfs
1018   if modprobe efivarfs &>/dev/null ; then
1019     efivars_loaded=true
1020   fi
1021
1022   if [ -d /sys/firmware/efi ] ; then
1023     einfo "EFI support detected."
1024     return 0
1025   fi
1026
1027   if ! [ -d /sys/firmware/efi ] && [ "${efivars_loaded:-}" = "true" ] ; then
1028     einfo "EFI support detected, but system seems to be running in BIOS mode."
1029   fi
1030
1031   return 1
1032 }
1033 # }}}
1034
1035 # make sure the user is aware of the used configuration {{{
1036 checkconfiguration()
1037 {
1038
1039 if [ -z "$VIRTUAL" ] ; then
1040   if efi_support ; then
1041     if [ -z "$_opt_efi" ] ; then
1042       ewarn "EFI support detected but no --efi option given, please consider enabling it."
1043     fi
1044   else
1045     if [ -n "$_opt_efi" ] ; then
1046       eerror "EFI option used but no EFI support detected."
1047       bailout 1
1048     fi
1049   fi
1050 fi
1051
1052 if [ -n "$AUTOINSTALL" ] ; then
1053    if checkforrun ; then
1054       eerror "Exiting as requested"
1055       bailout 1
1056    fi
1057 elif [ -n "$INTERACTIVE" ] ; then
1058
1059    INFOTEXT="Please recheck configuration before execution:
1060    "
1061    [ -n "$TARGET" ]  && INFOTEXT="$INFOTEXT
1062    Target:          $TARGET"
1063    [ -n "$GRUB" ]    && INFOTEXT="$INFOTEXT
1064    Install grub:    $GRUB"
1065    [ -n "$EFI" ]    && INFOTEXT="$INFOTEXT
1066    Install efi:     $EFI"
1067    [ -n "$RELEASE" ] && INFOTEXT="$INFOTEXT
1068    Using release:   $RELEASE"
1069    [ -n "$HOSTNAME" ] && INFOTEXT="$INFOTEXT
1070    Using hostname:  $HOSTNAME"
1071    [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
1072    Using mirror:    $MIRROR"
1073    [ -n "$ISO" ]  && INFOTEXT="$INFOTEXT
1074    Using ISO:       $ISO"
1075    [ -n "$ARCH" ]  && INFOTEXT="$INFOTEXT
1076    Using arch:      $ARCH"
1077    [ -n "$CONFFILES" ] && INFOTEXT="$INFOTEXT
1078    Config files:    $CONFFILES"
1079
1080    INFOTEXT="$INFOTEXT
1081
1082 Is this ok for you? Notice: selecting 'No' will exit ${PN}."
1083
1084    dialog --title "$PN" --no-collapse \
1085           --yesno "$INFOTEXT" 0 0 || bailout 0
1086
1087 else # if not running automatic installation display configuration and prompt for execution:
1088    einfo "$PN [${VERSION}] - Please recheck configuration before execution:"
1089    echo
1090    echo "   Target:          $TARGET"
1091
1092    # do not display if MNTPOINT is the default one
1093    case "$MNTPOINT" in /mnt/debootstrap*) ;; *) echo "   Mount point:     $MNTPOINT" ;; esac
1094
1095    if [ -n "$VIRTUAL" ] && [ "$GRUB_INSTALL" = 'yes' ] ; then
1096       echo "   Install grub:    yes"
1097       [ -n "$VMEFI" ]   && echo "   Install efi:     yes"   || echo "   Install efi:     no"
1098    else
1099      [ -n "$GRUB" ]     && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
1100      [ -n "$EFI" ]      && echo "   Install efi:     $EFI"  || echo "   Install efi:     no"
1101    fi
1102
1103    [ -n "$RELEASE" ]   && echo "   Using release:   $RELEASE"
1104    [ -n "$HOSTNAME" ]  && echo "   Using hostname:  $HOSTNAME"
1105    [ -n "$MIRROR" ]    && echo "   Using mirror:    $MIRROR"
1106    [ -n "$ISO" ]       && echo "   Using ISO:       $ISO"
1107    [ -n "$ARCH" ]      && echo "   Using arch:      $ARCH"
1108    [ -n "$CONFFILES" ] && echo "   Config files:    $CONFFILES"
1109    if [ -n "$VIRTUAL" ] ; then
1110       echo "   Deploying as Virtual Machine."
1111       if [ -n "$VMSIZE" ] && [ -n "$VMFILE" ]; then
1112          echo "   Using Virtual Disk file with size of ${VMSIZE}."
1113       fi
1114    fi
1115
1116    if [ ! -t 0 ] && [ -z "$ROOTPASSWORD" ] && [ -z "$NOPASSWORD" ] ; then
1117       echo
1118       echo "   You do not have a TTY allocated, your password will be shown in"
1119       echo "   plaintext on the terminal! If you are using SSH, try its -t option!"
1120    fi
1121
1122    echo
1123    echo "   Important! Continuing will delete all data from ${TARGET}!"
1124
1125    if [ -n "$FORCE" ] ; then
1126      einfo "Skip user acknowledgement as requested via --force option."
1127    else
1128      echo
1129      einfon "Is this ok for you? [y/N] "
1130      read -r a
1131      if ! [ "$a" = 'y' ] || [ "$a" = 'Y' ] ; then
1132         eerror "Exiting as requested."
1133         bailout 1
1134      fi
1135    fi
1136 fi
1137 }
1138 # }}}
1139
1140 # interactive mode {{{
1141 interactive_mode()
1142 {
1143   check4progs dialog || bailout 1
1144
1145   welcome_dialog
1146
1147   prompt_for_release
1148
1149   prompt_for_swraid
1150
1151   prompt_for_target
1152
1153   prompt_for_bootmanager
1154
1155   prompt_for_hostname
1156
1157   prompt_for_password
1158
1159   prompt_for_mirror
1160 }
1161
1162 # run interactive mode if we didn't get the according configuration yet
1163 if [ -z "$TARGET" ] || [ -n "$INTERACTIVE" ] ; then
1164    # only target might be unset, so make sure the INTERACTIVE flag is set as well
1165    INTERACTIVE=1
1166    interactive_mode
1167 fi
1168 # }}}
1169
1170 # architecture setup {{{
1171 if [ -n "$ARCH" ] ; then
1172    ARCHCMD="--arch $ARCH"
1173    ARCHINFO=" (${ARCH})"
1174 else
1175    ARCH="$(dpkg --print-architecture)"
1176    ARCHCMD="--arch $ARCH"
1177    ARCHINFO=" (${ARCH})"
1178 fi
1179
1180 if [ -z "${ARCH:-}" ] ; then
1181   eerror 'Architecture neither set (environment variable ARCH), nor could be automatically identified (using dpkg).'
1182   eerror 'Consider setting the --arch ... option.'
1183   bailout 1
1184 fi
1185 # }}}
1186
1187 # It is not possible to build amd64 on i686. {{{
1188 CURRENT_ARCH="$(uname -m)"
1189 if [ "$CURRENT_ARCH" != "x86_64" ] ; then
1190    if [ "$ARCH" = "amd64" ] ; then
1191       eerror "It is not possible to build amd64 on $CURRENT_ARCH. Consider installing and booting the 'linux-image-amd64' kernel or using '--arch i386' instead."
1192       bailout 1
1193    fi
1194 fi
1195 # }}}
1196
1197 # Support for generic release codenames is unavailable. {{{
1198 if [ "$RELEASE" = "stable" ] || [ "$RELEASE" = "testing" ] ; then
1199    eerror "Generic release codenames (stable, testing) are unsupported. \
1200 Please use specific codenames such as bullseye or bookworm."
1201    bailout 1
1202 fi
1203 # }}}
1204
1205 checkconfiguration
1206
1207 # finally make sure at least $TARGET is set [the partition for the new system] {{{
1208 if [ -n "$TARGET" ] ; then
1209    SHORT_TARGET="${TARGET##*/}"
1210 else
1211    eerror "Please adjust $CONFFILES/config or..."
1212    eerror "... use the interactive version for configuration before running ${0}"
1213    bailout 1
1214 fi
1215 # }}}
1216
1217 # stages setup {{{
1218 if [ -z "$STAGES" ] ; then
1219    STAGES="/var/cache/grml-debootstrap/stages_${SHORT_TARGET}"
1220    [ -d "$STAGES" ] || mkdir -p "$STAGES"
1221 fi
1222
1223 if [ -r "$STAGES"/grml-debootstrap ] ; then
1224    if grep -q 'done' "${STAGES}/grml-debootstrap" ; then
1225       eerror "Error: grml-debootstrap has been executed already, won't continue therefore."
1226       eerror "If you want to re-execute grml-debootstrap just manually remove ${STAGES}"
1227    fi
1228 fi
1229 # }}}
1230
1231 # partition handling {{{
1232 PARTITION=''
1233 DIRECTORY=''
1234
1235 set_target_directory(){
1236     # assume we are installing into a directory, don't run mkfs and grub related stuff therefore
1237     DIRECTORY=1
1238     MNTPOINT="$TARGET"
1239     MKFS=''
1240     TUNE2FS=''
1241     FSCK=''
1242     # make sure we normalise the path to an absolute directory name so something like:
1243     #  mkdir -p foo/a bar/a; (cd foo; grml-debootstrap -t a)&; (cd bar; grml-debootstrap -t a)&; wait
1244     # works
1245     TARGET="$(readlink -f "$TARGET")"
1246 }
1247
1248 if [ -b "$TARGET" ] || [ -n "$VIRTUAL" ] ; then
1249     PARTITION=1
1250 else
1251     # $TARGET was not detected as block device, but we do not want to create target directory in /dev/
1252     if [[ $TARGET == "/dev/"* ]]; then
1253       eerror "Error: Will not create target directory $TARGET in /dev."
1254       eerror "  Please check the partition(s) of the blockdevice."
1255       bailout 1
1256     fi
1257     set_target_directory
1258 fi
1259 # }}}
1260
1261 # make sure we have the right syntax when using an iso image {{{
1262 if [ -n "$ISO" ] ; then
1263    case $ISO in
1264       file*) # do nothing
1265       ;;
1266       *)
1267       ISO=file:$ISO
1268       ;;
1269    esac
1270 fi
1271 ISODIR=${ISO##file:}
1272 ISODIR=${ISODIR%%/}
1273 # }}}
1274
1275 # Debian ISOs do not contain signed Release files {{{
1276 if [ -n "$ISO" ] ; then
1277     DEBOOTSTRAP_OPT="$DEBOOTSTRAP_OPT --no-check-gpg"
1278 fi
1279 # }}}
1280
1281 # create filesystem {{{
1282 mkfs() {
1283   if [ -n "$DIRECTORY" ] ; then
1284      einfo "Running grml-debootstrap on a directory, skipping mkfs stage."
1285      return 0
1286   fi
1287
1288   if grep -q "$TARGET" /proc/mounts ; then
1289     eerror "$TARGET already mounted, exiting to avoid possible damage. (Manually unmount $TARGET)"
1290     bailout 1
1291   fi
1292
1293   # mkfs.ext* might prompt with "/dev/sdX# contains a ext* file system
1294   # created on ... Proceed anyway? (y,n)" which we want to skip in force mode
1295   if [ -n "$MKFS" ] && [ -n "$FORCE" ] ; then
1296     case "$MKFS" in
1297       mkfs.ext*)
1298         einfo "Enabling force option (-F) for mkfs.ext* tool as requested via --force switch."
1299         MKFS_OPTS="$MKFS_OPTS -F"
1300         ;;
1301     esac
1302   fi
1303
1304   # starting with e2fsprogs 1.43~WIP.2015.05.18-1 mkfs.ext4 enables the metadata_csum feature
1305   # by default, which requires a recent version of tune2fs on the target system then,
1306   # so disable this feature for older Debian releases where it's known to be unsupported
1307   if [ -n "$MKFS" ] && [ "$MKFS" = "mkfs.ext4" ] ; then
1308     case "$RELEASE" in
1309       jessie)
1310         # assume a more recent version if we can't identify the version via dpkg-query
1311         local e2fsprogs_version
1312         e2fsprogs_version="$(dpkg-query --show --showformat='${Version}' e2fsprogs 2>/dev/null || echo 1.44)"
1313         if [ -n "$e2fsprogs_version" ] && dpkg --compare-versions "$e2fsprogs_version" ge '1.43~WIP.2015.05.18-1' ; then
1314           einfo "Disabling metadata_csum feature for $MKFS as $RELEASE doesn't support it."
1315           MKFS_OPTS="$MKFS_OPTS -O ^metadata_csum"
1316         fi
1317         ;;
1318     esac
1319   fi
1320
1321   # starting with e2fsprogs v1.47.0 mkfs.ext4 enables the metadata_csum_seed feature
1322   # by default, which requires Linux kernel >=4.4, e2fsprogs >=1.43, according GRUB etc.
1323   # Disable this feature for Debian releases older than bookworm
1324   if [ -n "$MKFS" ] && [ "$MKFS" = "mkfs.ext4" ] ; then
1325     case "$RELEASE" in
1326       jessie|stretch|buster|bullseye)
1327         local e2fsprogs_version
1328         # assume a more recent version if we can't identify the version via dpkg-query
1329         e2fsprogs_version="$(dpkg-query --show --showformat='${Version}' e2fsprogs 2>/dev/null || echo 1.47)"
1330         if [ -n "$e2fsprogs_version" ] && dpkg --compare-versions "$e2fsprogs_version" ge '1.43' ; then
1331           einfo "Disabling metadata_csum_seed feature for $MKFS as $RELEASE doesn't support it."
1332           MKFS_OPTS="$MKFS_OPTS -O ^metadata_csum_seed"
1333         fi
1334         ;;
1335     esac
1336   fi
1337
1338   if [ -n "$MKFS" ] ; then
1339
1340     if [ -n "${ARM_EFI_TARGET}" ] ; then
1341       einfo "Running mkfs.fat $MKFS_OPTS on $ARM_EFI_TARGET"
1342       mkfs.fat -n "EFI" "$ARM_EFI_TARGET"
1343       MKFS_OPTS="$MKFS_OPTS -L LINUX"
1344     fi
1345
1346     einfo "Running $MKFS $MKFS_OPTS on $TARGET"
1347     # shellcheck disable=SC2086
1348     "$MKFS" $MKFS_OPTS "$TARGET"
1349
1350     if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1351       if ! echo "$MKFS" | grep -q "mkfs.ext" ; then
1352         eerror "Not changing disk uuid for $TARGET because $MKFS doesn't seem to match for ext{2,3,4} file system"
1353         bailout 1
1354       else
1355         einfo "Changing disk uuid for $TARGET to fixed (non-random) value $DISK_IDENTIFIER using tune2fs"
1356         tune2fs "$TARGET" -U "$DISK_IDENTIFIER" </dev/null
1357       fi
1358     fi
1359
1360     if [ -n "$VIRTUAL" ] && [ -n "$EFI_TARGET" ]; then
1361       einfo "Creating FAT filesystem on $EFI_TARGET"
1362       mkfs.fat -F32 -n "EFI" "$EFI_TARGET"
1363     fi
1364
1365     # make sure /dev/disk/by-uuid/... is up2date, otherwise grub
1366     # will fail to detect the uuid in the chroot
1367     if [ -n "$VIRTUAL" ] ; then
1368       einfo "Virtual environment doesn't require blockdev --rereadpt, skipping therefore"
1369     elif echo "$TARGET" | grep -q "/dev/md" ; then
1370       blockdev --rereadpt "${TARGET}"
1371     else
1372       # if we deploy to /dev/sdX# then let's see if /dev/sdX exists
1373       local main_device="${TARGET%%[0-9]*}"
1374       # sanity check to not try to e.g. access /dev/loop if we get /dev/loop0
1375       if ! [ -f "/sys/block/$(basename "${main_device}")/$(basename "${TARGET}")/dev" ] ; then
1376         einfo "No underlying block device for $TARGET identified, skipping blockdev --rereadpt."
1377       else
1378         udevadm settle
1379         # ensure we give blockdev up to 30 seconds/retries
1380         local timeout=30
1381         local success=0
1382         while [ "$timeout" -gt 0 ] ; do
1383           ((timeout--))
1384           if blockdev --rereadpt "${main_device}" ; then
1385             success=1
1386             break
1387           else
1388             ewarn "Failed to reread partition table of ${main_device} [${timeout} retries left]"
1389             sleep 1
1390           fi
1391         done
1392
1393         if [ "${success}" = "0" ] ; then
1394           eerror "Error: failed to reread partition table, giving up."
1395           bailout 1
1396         fi
1397       fi
1398     fi
1399     # give the system 2 seconds, otherwise we might run into
1400     # race conditions :-/
1401     sleep 2
1402
1403   fi
1404 }
1405 # }}}
1406
1407 # retrieve ID_FS_UUID {{{
1408 identify_target_uuid() {
1409   local device="$1"
1410
1411   if ! [ -b "$device" ] ; then
1412     return 1
1413   fi
1414
1415   eval "$(blkid -o udev "$1" 2>/dev/null)"
1416
1417   if [ -n "$ID_FS_UUID" ] ; then
1418     echo "$ID_FS_UUID"
1419   else
1420     return 1
1421   fi
1422 }
1423 # }}}
1424
1425 # identify TARGET_UUID {{{
1426 mountpoint_to_blockdevice() {
1427   TARGET_UUID=''
1428
1429   TARGET_UUID=$(identify_target_uuid "$TARGET" 2>/dev/null || true)
1430   if [ -n "$TARGET_UUID" ] ; then
1431     einfo "Identified UUID $TARGET_UUID for $TARGET"
1432     return 0
1433   fi
1434
1435   # $TARGET might be a mountpoint and not a blockdevice, search for according entry
1436   for file in /sys/block/*/*/dev ; do
1437     if grep -q "^$(mountpoint -d "${TARGET}")$" "$file" ; then
1438       local dev
1439       dev="${file%/dev}"
1440       dev="/dev/${dev##*/}"
1441       TARGET_UUID=$(identify_target_uuid "$dev" 2>/dev/null || true)
1442
1443       if [ -n "$TARGET_UUID" ] ; then
1444         einfo "Identified UUID $TARGET_UUID for $TARGET (via $file)"
1445         return 0
1446       fi
1447     fi
1448   done
1449 }
1450 # }}}
1451
1452 # modify filesystem settings {{{
1453 tunefs() {
1454   if [ -n "$TUNE2FS" ] && echo "$MKFS" | grep -q "mkfs.ext" ; then
1455      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
1456      $TUNE2FS "$TARGET" </dev/null
1457   fi
1458 }
1459 # }}}
1460
1461 # mount the new partition or if it's a directory do nothing at all {{{
1462 mount_target() {
1463   if [ -n "$DIRECTORY" ] ; then
1464      einfo "Running grml-debootstrap on a directory, nothing to mount."
1465   else
1466      if grep -q "$TARGET" /proc/mounts ; then
1467         ewarn "$TARGET already mounted, continuing anyway."
1468      else
1469        if ! [ -d "${MNTPOINT}" ] ; then
1470           [ -n "$VIRTUAL" ] || mkdir -p "${MNTPOINT}"
1471        fi
1472        einfo "Mounting $TARGET to $MNTPOINT"
1473        mkdir -p "$MNTPOINT"
1474        mount -o rw,suid,dev "$TARGET" "$MNTPOINT"
1475      fi
1476   fi
1477   if [ -n "$ISODIR" ] ; then
1478      einfo "Mounting Debian image loopback to $MNTPOINT/$ISODIR."
1479      mkdir -p "$MNTPOINT/$ISODIR"
1480      mount --bind "$ISODIR" "$MNTPOINT/$ISODIR"
1481   fi
1482 }
1483 # }}}
1484
1485 # prepare VM image for usage with debootstrap {{{
1486 prepare_vm() {
1487   if [ -z "$VIRTUAL" ] ; then
1488      return 0 # be quiet by intention
1489   fi
1490
1491   if [ -b "$TARGET" ] && [ -n "$VMFILE" ] ; then
1492      eerror "Error: specified virtual disk target ($TARGET) is an existing block device."
1493      bailout 1
1494   fi
1495   if [ ! -b "$TARGET" ] && [ -z "$VMFILE" ] ; then
1496      eerror "Error: specified virtual disk target ($TARGET) does not exist yet."
1497      bailout 1
1498   fi
1499
1500   # make sure loop module is present and a usable loop device exists
1501   modprobe loop || true
1502   if ! losetup -f >/dev/null 2>&1; then
1503     eerror "Error finding usable loop device"
1504     bailout 1
1505   fi
1506
1507   # if dm-mod isn't available then kpartx will fail with
1508   # "Is device-mapper driver missing from kernel? [...]"
1509   modprobe dm-mod || true
1510   if ! grep -q 'device-mapper' /proc/misc >/dev/null 2>&1 ; then
1511     eerror "Device-mapper support missing in kernel."
1512     bailout 1
1513   fi
1514
1515   ORIG_TARGET="$TARGET" # store for later reuse
1516
1517   if [ -n "$VMFILE" ]; then
1518     qemu-img create -f raw "${TARGET}" "${VMSIZE}"
1519   fi
1520   if [ -n "$VMEFI" ]; then
1521     parted -s "${TARGET}" 'mklabel gpt'
1522     parted -s "${TARGET}" 'mkpart ESP fat32 1MiB 101MiB'
1523     parted -s "${TARGET}" 'set 1 boot on'
1524     parted -s "${TARGET}" 'mkpart bios_grub 101MiB 102MiB'
1525     parted -s "${TARGET}" 'set 2 bios_grub on'
1526     parted -s "${TARGET}" 'mkpart primary ext4 102MiB 100%'
1527
1528   else
1529     # arm64 support largely only exists for GPT
1530     if [ "$ARCH" = 'arm64' ]; then
1531       einfo "Setting up GPT partitions for arm64"
1532       parted -s "${TARGET}" 'mklabel gpt'
1533       parted -s "${TARGET}" 'mkpart ESP fat32 1MiB 10MiB'
1534       parted -s "${TARGET}" 'set 1 boot on'
1535       parted -s "${TARGET}" 'mkpart LINUX ext4 10MiB 100%'
1536     else
1537       parted -s "${TARGET}" 'mklabel msdos'
1538       if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1539         einfo "Adjusting disk signature to a fixed (non-random) value"
1540         MBRTMPFILE=$(mktemp)
1541         dd if="${TARGET}" of="${MBRTMPFILE}" bs=512 count=1
1542         echo -en "\\x41\\x41\\x41\\x41" | dd of="${MBRTMPFILE}" conv=notrunc seek=440 bs=1
1543         dd if="${MBRTMPFILE}" of="${TARGET}" conv=notrunc
1544       fi
1545       parted -s "${TARGET}" 'mkpart primary ext4 4MiB 100%'
1546       parted -s "${TARGET}" 'set 1 boot on'
1547     fi
1548   fi
1549
1550   DEVINFO=$(kpartx -asv "$TARGET") # e.g. 'add map loop0p1 (254:5): 0 20477 linear 7:0 3' - will be multi-line for arm64
1551   if [ -z "${DEVINFO}" ] ; then
1552     eerror "Error setting up loopback device."
1553     bailout 1
1554   fi
1555
1556   # if we're building for arm64, we operate on the first line of $DEVINFO which is the EFI partition
1557   if [ "$ARCH" = 'arm64' ]; then
1558     LOOP_PART="${DEVINFO##add map }" # 'loop0p1 (254:5): 0 20477 linear 7:0 3'
1559     LOOP_PART="${LOOP_PART// */}"    # 'loop0p1'
1560     LOOP_DISK="${LOOP_PART%p*}"      # 'loop0'
1561     export ARM_EFI_TARGET="/dev/mapper/$LOOP_PART"
1562     DEVINFO=${DEVINFO##*$'\n'} # now set $DEVINFO to the last line which is the OS partition
1563   fi
1564
1565   # hopefully this always works as expected
1566   LOOP_PART="${DEVINFO##add map }" # 'loop0p1 (254:5): 0 20477 linear 7:0 3'
1567   LOOP_PART="${LOOP_PART// */}"    # 'loop0p1'
1568   if [ -n "$VMEFI" ]; then
1569     export EFI_TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop0p1'
1570     LOOP_PART="${LOOP_PART%p1}p3"
1571   fi
1572   LOOP_DISK="${LOOP_PART%p*}"      # 'loop0'
1573   export TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop0p1'
1574
1575   if [ -z "$TARGET" ] ; then
1576      eerror "Error: target could not be set to according /dev/mapper/* device."
1577      bailout 1
1578   fi
1579 }
1580 # }}}
1581
1582 # make VM image bootable {{{
1583 grub_install() {
1584   if [ -z "${VIRTUAL}" ] ; then
1585      return 0
1586   fi
1587   if [ "${GRUB_INSTALL}" != "yes" ] ; then
1588     einfo "Not installing GRUB as requested via \$GRUB_INSTALL=$GRUB_INSTALL"
1589     return 0
1590   fi
1591
1592   if ! mount "${TARGET}" "${MNTPOINT}" ; then
1593     eerror "Error: Mounting ${TARGET} failed, can not continue."
1594     bailout 1
1595   fi
1596
1597   if [ -n "${ARM_EFI_TARGET}" ]; then
1598     mkdir -p "${MNTPOINT}"/boot/efi
1599     if ! mount "${ARM_EFI_TARGET}" "${MNTPOINT}"/boot/efi ; then
1600       eerror "Error: Mounting ${ARM_EFI_TARGET} failed, can not continue."
1601       bailout 1
1602     fi
1603   fi
1604
1605   mount -t proc none "${MNTPOINT}"/proc
1606   mount -t sysfs none "${MNTPOINT}"/sys
1607   mount -t devtmpfs udev "${MNTPOINT}"/dev
1608   mount -t devpts devpts "${MNTPOINT}"/dev/pts
1609
1610   if [ -n "$ARM_EFI_TARGET" ]; then
1611     einfo "Installing Grub as bootloader into EFI."
1612
1613     chroot "${MNTPOINT}" grub-install --target=arm64-efi --efi-directory=/boot/efi --bootloader-id=debian --recheck --no-nvram --removable
1614   # Has chroot-script installed GRUB to MBR using grub-install (successfully), already?
1615   # chroot-script skips installation for unset ${GRUB}
1616   elif [[ -z "${GRUB}" ]] || ! dd if="${GRUB}" bs=512 count=1 2>/dev/null | cat -v | grep -Fq GRUB; then
1617     einfo "Installing Grub as bootloader."
1618
1619     if ! chroot "${MNTPOINT}" dpkg --list grub-pc 2>/dev/null | grep -q '^ii' ; then
1620       echo "Notice: grub-pc package not present yet, installing it therefore."
1621       # shellcheck disable=SC2086
1622       DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-pc
1623     fi
1624
1625     mkdir -p "${MNTPOINT}/boot/grub"
1626     if ! [ -d "${MNTPOINT}"/usr/lib/grub/i386-pc/ ] ; then
1627       eerror "Error: grub not installed inside Virtual Machine. Can not install bootloader."
1628       bailout 1
1629     fi
1630     cp -a "${MNTPOINT}"/usr/lib/grub/i386-pc "${MNTPOINT}/boot/grub/"
1631
1632     if [ -n "$VMEFI" ]; then
1633
1634       mkdir -p "${MNTPOINT}"/boot/efi
1635       mount -t vfat "${EFI_TARGET}" "${MNTPOINT}"/boot/efi
1636
1637       if ! chroot "${MNTPOINT}" dpkg --list shim-signed 2>/dev/null | grep -q '^ii' ; then
1638         echo "Notice: shim-signed package not present yet, installing it therefore."
1639         # shellcheck disable=SC2086
1640         DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS shim-signed
1641       fi
1642
1643       if [ "$(dpkg --print-architecture)" = "arm64" ]; then
1644         if ! chroot "${MNTPOINT}" dpkg --list grub-efi-arm64-signed 2>/dev/null | grep -q '^ii' ; then
1645           echo "Notice: grub-efi-arm64-signed package not present yet, installing it therefore."
1646           # shellcheck disable=SC2086
1647           DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-efi-arm64-bin grub-efi-arm64-signed
1648         fi
1649         chroot "$MNTPOINT" grub-install --target=arm64-efi --efi-directory=/boot/efi --uefi-secure-boot --removable "/dev/$LOOP_DISK"
1650       elif [ "$(dpkg --print-architecture)" = "i386" ]; then
1651         if ! chroot "${MNTPOINT}" dpkg --list grub-efi-ia32-signed 2>/dev/null | grep -q '^ii' ; then
1652           echo "Notice: grub-efi-ia32-signed package not present yet, installing it therefore."
1653           # shellcheck disable=SC2086
1654           DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-efi-ia32-bin grub-efi-ia32-signed
1655         fi
1656         chroot "$MNTPOINT" grub-install --target=i386-efi --efi-directory=/boot/efi --uefi-secure-boot --removable "/dev/$LOOP_DISK"
1657         chroot "$MNTPOINT" grub-install --target=i386-pc "/dev/$LOOP_DISK"
1658       else
1659         if ! chroot "${MNTPOINT}" dpkg --list grub-efi-amd64-signed 2>/dev/null | grep -q '^ii' ; then
1660           echo "Notice: grub-efi-amd64-signed package not present yet, installing it therefore."
1661           # shellcheck disable=SC2086
1662           DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-efi-amd64-bin grub-efi-amd64-signed
1663         fi
1664         chroot "$MNTPOINT" grub-install --target=x86_64-efi --efi-directory=/boot/efi --uefi-secure-boot --removable "/dev/$LOOP_DISK"
1665         chroot "$MNTPOINT" grub-install --target=i386-pc "/dev/$LOOP_DISK"
1666       fi
1667     else
1668       dd if="${MNTPOINT}/usr/lib/grub/i386-pc/boot.img" of="${ORIG_TARGET}" conv=notrunc bs=440 count=1
1669       case "${_opt_filesystem}" in
1670         f2fs)
1671           chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos f2fs
1672           ;;
1673         xfs)
1674           chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos xfs
1675           ;;
1676         # NOTE - we might need to distinguish between further filesystems
1677         *)
1678           chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos ext2
1679           ;;
1680       esac
1681
1682       dd if="${MNTPOINT}/tmp/core.img" of="${ORIG_TARGET}" conv=notrunc seek=1
1683       rm -f "${MNTPOINT}/tmp/core.img"
1684     fi
1685   fi
1686
1687   # workaround for Debian bug #918590 with lvm + udev:
1688   # WARNING: Device /dev/... not initialized in udev database even after waiting 10000000 microseconds
1689   if [ -d /run/udev ] ; then
1690     einfo "Setting up bind-mount /run/udev"
1691     mkdir -p "${MNTPOINT}"/run/udev
1692     mount --bind /run/udev "${MNTPOINT}"/run/udev
1693   fi
1694
1695   if [ -n "${BOOT_APPEND}" ] ; then
1696     echo "Adding BOOT_APPEND configuration ['${BOOT_APPEND}'] to /etc/default/grub."
1697     sed -i "/GRUB_CMDLINE_LINUX_DEFAULT/ s#\"\$# ${BOOT_APPEND}\"#" "${MNTPOINT}/etc/default/grub"
1698   fi
1699
1700   einfo "Updating grub configuration file."
1701   chroot "${MNTPOINT}" update-grub
1702   chroot "${MNTPOINT}" sync
1703
1704   case "$RELEASE" in
1705     jessie)
1706       einfo "Applying workaround for GRUB font path bug in jessie (Debian #787685)."
1707       mkdir -p "${MNTPOINT}/boot/grub/fonts/"
1708       cp "${MNTPOINT}/usr/share/grub/unicode.pf2" "${MNTPOINT}/boot/grub/fonts/"
1709       ;;
1710   esac
1711
1712   if grep -q '^GRUB_DISABLE_LINUX_UUID=.*true' "${MNTPOINT}"/etc/default/grub 2>/dev/null ; then
1713     ewarn "GRUB_DISABLE_LINUX_UUID is set to true in /etc/default/grub, not adjusting root= in grub.cfg."
1714     ewarn "Please note that your system might NOT be able to properly boot."
1715   elif [ -z "$ARM_EFI_TARGET" ]; then
1716     einfo "Adjusting grub.cfg for successful boot sequence."
1717     sed -i "s;root=[^ ]\\+;root=UUID=$TARGET_UUID;" "${MNTPOINT}"/boot/grub/grub.cfg
1718   fi
1719
1720   # workaround for Debian bug #918590 with lvm + udev:
1721   # WARNING: Device /dev/... not initialized in udev database even after waiting 10000000 microseconds
1722   try_umount 3 "${MNTPOINT}"/run/udev
1723
1724   try_umount 3 "${MNTPOINT}"/proc
1725   try_umount 3 "${MNTPOINT}"/sys
1726   try_umount 3 "${MNTPOINT}"/dev/pts
1727   try_umount 3 "${MNTPOINT}"/dev
1728
1729   try_umount 3 "${MNTPOINT}"/boot/efi
1730
1731 }
1732 # }}}
1733
1734 # unmount VM image {{{
1735 umount_target() {
1736   if [ -z "${VIRTUAL}" ] ; then
1737      return 0
1738   fi
1739
1740   try_umount 3 "${MNTPOINT}"/boot/efi
1741
1742   try_umount 3 "${MNTPOINT}"
1743   kpartx -d "${ORIG_TARGET}" >/dev/null
1744   # Workaround for a bug in kpartx which doesn't clean up properly,
1745   # see Debian Bug #891077 and Github-PR grml/grml-debootstrap#112
1746   if dmsetup ls | grep -q "^${LOOP_PART} "; then
1747     kpartx -d "/dev/${LOOP_DISK}" >/dev/null
1748   fi
1749 }
1750 # }}}
1751
1752 # install main chroot {{{
1753 debootstrap_system() {
1754   if [ "$_opt_nodebootstrap" ]; then
1755      einfo "Skipping debootstrap as requested."
1756      return
1757   fi
1758
1759   if grep -q "$MNTPOINT" /proc/mounts || [ -n "$DIRECTORY" ] ; then
1760     :
1761   else
1762     eerror "Error: $MNTPOINT not mounted, can not continue."
1763     eend 1 ; exit 1
1764   fi
1765
1766   if [ -n "$ISO" ] ; then
1767     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${ISO}"
1768     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO"
1769     # shellcheck disable=SC2086
1770     "$DEBOOTSTRAP" $ARCHCMD $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$ISO"
1771   else
1772     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}"
1773     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR"
1774     # shellcheck disable=SC2086
1775     "$DEBOOTSTRAP" $ARCHCMD $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$MIRROR"
1776   fi
1777 }
1778 # }}}
1779
1780 # prepare chroot via chroot-script {{{
1781 preparechroot() {
1782   einfo "Preparing chroot system"
1783
1784   # provide variables to chroot system
1785   CHROOT_VARIABLES="/var/cache/grml-debootstrap/variables_${SHORT_TARGET}"
1786   touch "$CHROOT_VARIABLES"
1787   chmod 600 "$CHROOT_VARIABLES" # make sure nobody except root can read it
1788   echo "# Configuration of ${PN}"                                                                                   > "$CHROOT_VARIABLES"
1789   [ -n "$ARCH" ]                      && echo "ARCH='${ARCH//\'/\'\\\'\'}'"                                         >> "$CHROOT_VARIABLES"
1790   [ -n "$BACKPORTREPOS" ]             && echo "BACKPORTREPOS='${BACKPORTREPOS//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1791   [ -n "$BOOT_APPEND" ]               && echo "BOOT_APPEND='${BOOT_APPEND//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1792   [ -n "$CHROOT_SCRIPTS" ]            && echo "CHROOT_SCRIPTS='${CHROOT_SCRIPTS//\'/\'\\\'\'}'"                     >> "$CHROOT_VARIABLES"
1793   [ -n "$COMPONENTS" ]                && echo "COMPONENTS='${COMPONENTS//\'/\'\\\'\'}'"                             >> "$CHROOT_VARIABLES"
1794   [ -n "$CONFFILES" ]                 && echo "CONFFILES='${CONFFILES//\'/\'\\\'\'}'"                               >> "$CHROOT_VARIABLES"
1795   [ -n "$DEBCONF" ]                   && echo "DEBCONF='${DEBCONF//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1796   [ -n "$DEBIAN_FRONTEND" ]           && echo "DEBIAN_FRONTEND='${DEBIAN_FRONTEND//\'/\'\\\'\'}'"                   >> "$CHROOT_VARIABLES"
1797   [ -n "$DEBOOTSTRAP" ]               && echo "DEBOOTSTRAP='${DEBOOTSTRAP//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1798   [ -n "$DEFAULT_LOCALES" ]           && echo "DEFAULT_LOCALES='${DEFAULT_LOCALES//\'/\'\\\'\'}'"                   >> "$CHROOT_VARIABLES"
1799   [ -n "$DEFAULT_LANGUAGE" ]          && echo "DEFAULT_LANGUAGE='${DEFAULT_LANGUAGE//\'/\'\\\'\'}'"                 >> "$CHROOT_VARIABLES"
1800   [ -n "$EXTRAPACKAGES" ]             && echo "EXTRAPACKAGES='${EXTRAPACKAGES//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1801   [ -n "$EFI" ]                       && echo "EFI='${EFI//\'/\'\\\'\'}'"                                           >> "$CHROOT_VARIABLES"
1802   [ -n "$FALLBACK_MIRROR" ]           && echo "FALLBACK_MIRROR='${FALLBACK_MIRROR//\'/\'\\\'\'}'"                   >> "$CHROOT_VARIABLES"
1803   [ -n "$FILESYSTEM" ]                && echo "FILESYSTEM='${FILESYSTEM//\'/\'\\\'\'}'"                             >> "$CHROOT_VARIABLES"
1804   [ -n "$FORCE" ]                     && echo "FORCE='${FORCE//\'/\'\\\'\'}'"                                       >> "$CHROOT_VARIABLES"
1805   [ -n "$GRMLREPOS" ]                 && echo "GRMLREPOS='${GRMLREPOS//\'/\'\\\'\'}'"                               >> "$CHROOT_VARIABLES"
1806   [ -n "$GRUB" ]                      && echo "GRUB='${GRUB//\'/\'\\\'\'}'"                                         >> "$CHROOT_VARIABLES"
1807   [ -n "$HOSTNAME" ]                  && echo "HOSTNAME='${HOSTNAME//\'/\'\\\'\'}'"                                 >> "$CHROOT_VARIABLES"
1808   [ -n "$INITRD" ]                    && echo "INITRD='${INITRD//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1809   [ -n "$INITRD_GENERATOR" ]          && echo "INITRD_GENERATOR='${INITRD_GENERATOR//\'/\'\\\'\'}'"                 >> "$CHROOT_VARIABLES"
1810   [ -n "$INITRD_GENERATOR_OPTS" ]     && echo "INITRD_GENERATOR_OPTS='${INITRD_GENERATOR_OPTS//\'/\'\\\'\'}'"       >> "$CHROOT_VARIABLES"
1811   [ -n "$INSTALL_NOTES" ]             && echo "INSTALL_NOTES='${INSTALL_NOTES//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1812   [ -n "$ISODIR" ]                    && echo "ISODIR='${ISO//\'/\'\\\'\'}'"                                        >> "$CHROOT_VARIABLES"
1813   [ -n "$ISO" ]                       && echo "ISO='${ISO//\'/\'\\\'\'}'"                                           >> "$CHROOT_VARIABLES"
1814   [ -n "$KEEP_SRC_LIST" ]             && echo "KEEP_SRC_LIST='${KEEP_SRC_LIST//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1815   [ -n "$LOCALES" ]                   && echo "LOCALES='${LOCALES//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1816   [ -n "$MIRROR" ]                    && echo "MIRROR='${MIRROR//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1817   [ -n "$MKFS" ]                      && echo "MKFS='${MKFS//\'/\'\\\'\'}'"                                         >> "$CHROOT_VARIABLES"
1818   [ -n "$NOPASSWORD" ]                && echo "NOPASSWORD=\"true\""                                                 >> "$CHROOT_VARIABLES"
1819   [ -n "$NOKERNEL" ]                  && echo "NOKERNEL=\"true\""                                                   >> "$CHROOT_VARIABLES"
1820   [ -n "$PACKAGES" ]                  && echo "PACKAGES='${PACKAGES//\'/\'\\\'\'}'"                                 >> "$CHROOT_VARIABLES"
1821   [ -n "$POST_SCRIPTS" ]              && echo "POST_SCRIPTS='${POST_SCRIPTS//\'/\'\\\'\'}'"                         >> "$CHROOT_VARIABLES"
1822   [ -n "$PRE_SCRIPTS" ]               && echo "PRE_SCRIPTS='${PRE_SCRIPTS//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1823   [ -n "$RECONFIGURE" ]               && echo "RECONFIGURE='${RECONFIGURE//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1824   [ -n "$RELEASE" ]                   && echo "RELEASE='${RELEASE//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1825   [ -n "$RM_APTCACHE" ]               && echo "RM_APTCACHE='${RM_APTCACHE//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1826   [ -n "$ROOTPASSWORD" ]              && echo "ROOTPASSWORD='${ROOTPASSWORD//\'/\'\\\'\'}'"                         >> "$CHROOT_VARIABLES"
1827   [ -n "$SCRIPTS" ]                   && echo "SCRIPTS='${SCRIPTS//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1828   [ -n "$SECURE" ]                    && echo "SECURE='${SECURE//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1829   [ -n "$SELECTED_PARTITIONS" ]       && echo "SELECTED_PARTITIONS='${SELECTED_PARTITIONS//\'/\'\\\'\'}'"           >> "$CHROOT_VARIABLES"
1830   [ -n "$TARGET" ]                    && echo "TARGET='${TARGET//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1831   [ -n "$UPGRADE_SYSTEM" ]            && echo "UPGRADE_SYSTEM='${UPGRADE_SYSTEM//\'/\'\\\'\'}'"                     >> "$CHROOT_VARIABLES"
1832   [ -n "$TARGET_UUID" ]               && echo "TARGET_UUID='${TARGET_UUID//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1833   [ -n "$TIMEZONE" ]                  && echo "TIMEZONE='${TIMEZONE//\'/\'\\\'\'}'"                                 >> "$CHROOT_VARIABLES"
1834   [ -n "$TUNE2FS" ]                   && echo "TUNE2FS='${TUNE2FS//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1835   [ -n "$VMSIZE" ]                    && echo "VMSIZE='${VMSIZE//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1836
1837   cp $VERBOSE "${CONFFILES}"/chroot-script "${MNTPOINT}"/bin/chroot-script
1838   chmod 755 "${MNTPOINT}"/bin/chroot-script
1839   [ -d "$MNTPOINT"/etc/debootstrap/ ] || mkdir "$MNTPOINT"/etc/debootstrap/
1840
1841   # make sure we have our files for later use via chroot-script
1842   cp $VERBOSE "${CONFFILES}/config"           "${MNTPOINT}"/etc/debootstrap/
1843   # make sure we adjust the configuration variables accordingly:
1844   sed -i "s#RELEASE=.*#RELEASE=\"$RELEASE\"#" "${MNTPOINT}"/etc/debootstrap/config
1845   sed -i "s#TARGET=.*#TARGET=\"$TARGET\"#"    "${MNTPOINT}"/etc/debootstrap/config
1846   sed -i "s#GRUB=.*#GRUB=\"$GRUB\"#"          "${MNTPOINT}"/etc/debootstrap/config
1847
1848   # install notes:
1849   if [ -n "$INSTALL_NOTES" ] ; then
1850      [ -r "$INSTALL_NOTES" ] && cp "$INSTALL_NOTES" "${MNTPOINT}"/etc/debootstrap/
1851   fi
1852
1853   # package selection:
1854   if [ "$PACKAGES" = 'yes' ] ; then
1855     PACKAGES_FILE="packages"
1856
1857     if [ "$ARCH" = 'arm64' ]; then
1858       PACKAGES_FILE="packages-arm64"
1859     fi
1860
1861     cp $VERBOSE "${_opt_packages:-$CONFFILES/$PACKAGES_FILE}" \
1862       "${MNTPOINT}/etc/debootstrap/${PACKAGES_FILE}"
1863   fi
1864
1865   # debconf preseeding:
1866   _opt_debconf=${_opt_debconf:-$CONFFILES/debconf-selections}
1867   [ -f "${_opt_debconf}" ] && [ "$DEBCONF" = 'yes' ] && \
1868     cp $VERBOSE "${_opt_debconf}" "${MNTPOINT}"/etc/debootstrap/debconf-selections
1869
1870   # copy scripts that should be executed inside the chroot:
1871   _opt_chroot_scripts=${_opt_chroot_scripts:-$CONFFILES/chroot-scripts/}
1872   [ -d "$_opt_chroot_scripts" ] && [ "$CHROOT_SCRIPTS" = 'yes' ] && {
1873     mkdir -p "${MNTPOINT}"/etc/debootstrap/chroot-scripts
1874     cp -a $VERBOSE "${_opt_chroot_scripts}"/* "${MNTPOINT}"/etc/debootstrap/chroot-scripts/
1875   }
1876
1877   # notice: do NOT use $CHROOT_VARIABLES inside chroot but statically file instead!
1878   cp $VERBOSE "${CHROOT_VARIABLES}" "${MNTPOINT}"/etc/debootstrap/variables
1879
1880   cp $VERBOSE -a -L "${CONFFILES}"/extrapackages/ "${MNTPOINT}"/etc/debootstrap/
1881
1882   # make sure we can access network [relevant for cdebootstrap/mmdebstrap]
1883   [ -f "${MNTPOINT}"/etc/resolv.conf ] || cp $VERBOSE /etc/resolv.conf "${MNTPOINT}"/etc/resolv.conf
1884
1885   # setup default locales
1886   [ -n "$LOCALES" ] && cp $VERBOSE "${CONFFILES}"/locale.gen "${MNTPOINT}"/etc/locale.gen
1887
1888   # copy any existing files to chroot
1889   [ -d "${CONFFILES}"/bin   ] && cp $VERBOSE -a -L "${CONFFILES}"/bin/*   "${MNTPOINT}"/bin/
1890   [ -d "${CONFFILES}"/boot  ] && cp $VERBOSE -a -L "${CONFFILES}"/boot/*  "${MNTPOINT}"/boot/
1891   [ -d "${CONFFILES}"/etc   ] && cp $VERBOSE -a -L "${CONFFILES}"/etc/*   "${MNTPOINT}"/etc/
1892   [ -d "${CONFFILES}"/sbin  ] && cp $VERBOSE -a -L "${CONFFILES}"/sbin/*  "${MNTPOINT}"/sbin/
1893   [ -d "${CONFFILES}"/share ] && cp $VERBOSE -a -L "${CONFFILES}"/share/* "${MNTPOINT}"/share/
1894   [ -d "${CONFFILES}"/usr   ] && cp $VERBOSE -a -L "${CONFFILES}"/usr/*   "${MNTPOINT}"/usr/
1895   [ -d "${CONFFILES}"/var   ] && cp $VERBOSE -a -L "${CONFFILES}"/var/*   "${MNTPOINT}"/var/
1896
1897   # network setup
1898   DEFAULT_INTERFACES="# /etc/network/interfaces - generated by grml-debootstrap
1899
1900 # Include files from /etc/network/interfaces.d when using
1901 # ifupdown v0.7.44 or newer:
1902 #source-directory /etc/network/interfaces.d
1903
1904 auto lo
1905 iface lo inet loopback
1906
1907 allow-hotplug eth0
1908 iface eth0 inet dhcp
1909 "
1910
1911   # add dhcp setting for Predictable Network Interface Names
1912   if [ -x /bin/udevadm ]; then
1913     tmpfile=$(mktemp)
1914     for interface in /sys/class/net/*; do
1915       udevadm info --query=all --path="${interface}" > "${tmpfile}"
1916       # skip virtual devices, like bridges, vboxnet,...
1917       if grep -q 'P: /devices/virtual/net/' "${tmpfile}" ; then
1918         continue
1919       fi
1920
1921       # iterate over possible naming policies by precedence (see udev/net/link-config.c),
1922       # use and stop on first match to have same behavior as udev's link_config_apply()
1923       for property in ID_NET_NAME_FROM_DATABASE ID_NET_NAME_ONBOARD ID_NET_NAME_SLOT ID_NET_NAME_PATH ID_NET_NAME_MAC ; do
1924         if grep -q "${property}" "${tmpfile}" ; then
1925           interface=$(grep "${property}" "${tmpfile}" | sed -n -e "s/E: ${property}=\([^\$*]\)/\1/p")
1926           DEFAULT_INTERFACES="${DEFAULT_INTERFACES}
1927 allow-hotplug ${interface}
1928 iface ${interface} inet dhcp
1929 "
1930           break
1931         fi
1932       done
1933     done
1934     rm -f "${tmpfile}"
1935   fi
1936
1937   if [ -n "$NOINTERFACES" ] ; then
1938     einfo "Not installing /etc/network/interfaces as requested via --nointerfaces option"
1939   elif [ -n "$USE_DEFAULT_INTERFACES" ] ; then
1940     einfo "Installing default /etc/network/interfaces as requested via --defaultinterfaces options."
1941     mkdir -p "${MNTPOINT}/etc/network"
1942     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1943   elif [ -n "$VIRTUAL" ] ; then
1944     einfo "Setting up Virtual Machine, installing default /etc/network/interfaces"
1945     mkdir -p "${MNTPOINT}/etc/network"
1946     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1947   elif [ -r /etc/network/interfaces ] ; then
1948     einfo "Copying /etc/network/interfaces from host to target system"
1949     mkdir -p "${MNTPOINT}/etc/network"
1950     cp $VERBOSE /etc/network/interfaces "${MNTPOINT}/etc/network/interfaces"
1951   else
1952     ewarn "Couldn't read /etc/network/interfaces, installing default /etc/network/interfaces"
1953     mkdir -p "${MNTPOINT}/etc/network"
1954     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1955   fi
1956
1957   # install config file providing some example entries
1958   if [ -r /etc/network/interfaces.examples ] && [ ! -r "$MNTPOINT/etc/network/interfaces.examples" ] ; then
1959     mkdir -p "${MNTPOINT}/etc/network"
1960     cp /etc/network/interfaces.examples "$MNTPOINT/etc/network/interfaces.examples"
1961   fi
1962
1963   if [ -n "${SSHCOPYID}" ] ; then
1964     AUTHORIZED_KEYS_SOURCE=${AUTHORIZED_KEYS_SOURCE:-$HOME/.ssh/authorized_keys}
1965     AUTHORIZED_KEYS_TARGET=${AUTHORIZED_KEYS_TARGET:-$MNTPOINT/root/.ssh/}
1966     if ssh-add -L >/dev/null 2>&1 ; then
1967       einfo "Use locally available public keys to authorise root login on the target system as requested via --sshcopyid option."
1968       mkdir -p "${MNTPOINT}"/root/.ssh
1969       chmod 0700 "${MNTPOINT}"/root/.ssh
1970       if ! ssh-add -L >> "${MNTPOINT}"/root/.ssh/authorized_keys ; then
1971         eerror "Error: executing 'ssh-add -L' failed."
1972         bailout 1
1973       fi
1974     elif [ -f "$AUTHORIZED_KEYS_SOURCE" ]; then
1975       einfo "copying '$AUTHORIZED_KEYS_SOURCE' to '$AUTHORIZED_KEYS_TARGET' as requested via --sshcopyid option."
1976       mkdir -p "$AUTHORIZED_KEYS_TARGET"
1977       chmod 0700 "$AUTHORIZED_KEYS_TARGET"
1978       if ! cp "$AUTHORIZED_KEYS_SOURCE" "$AUTHORIZED_KEYS_TARGET" ; then
1979         eerror "Error: copying '$AUTHORIZED_KEYS_SOURCE' to '$AUTHORIZED_KEYS_TARGET' failed"
1980         bailout 1
1981       fi
1982     else
1983       eerror "Error: Could not open a connection to your authentication agent or the agent has no identities."
1984       bailout 1
1985     fi
1986   fi
1987
1988   if [ -n "${SSHCOPYAUTH}" ] ; then
1989     AUTHORIZED_KEYS_SOURCE=${AUTHORIZED_KEYS_SOURCE:-${HOME}/.ssh/authorized_keys}
1990
1991     if ! [ -f "${AUTHORIZED_KEYS_SOURCE}" ]; then
1992       eerror "Error: could not read '${AUTHORIZED_KEYS_SOURCE}' for setting up SSH key login."
1993       bailout 1
1994     fi
1995
1996     AUTHORIZED_KEYS_TARGET="${MNTPOINT}/root/.ssh/"
1997     einfo "Copying '${AUTHORIZED_KEYS_SOURCE}' to '${AUTHORIZED_KEYS_TARGET}' as requested via --sshcopyauth option."
1998     mkdir -p "${AUTHORIZED_KEYS_TARGET}"
1999     chmod 0700 "${AUTHORIZED_KEYS_TARGET}"
2000     if ! cp "${AUTHORIZED_KEYS_SOURCE}" "${AUTHORIZED_KEYS_TARGET}" ; then
2001       eerror "Error: copying '${AUTHORIZED_KEYS_SOURCE}' to '${AUTHORIZED_KEYS_TARGET}' failed."
2002       bailout 1
2003     fi
2004   fi
2005
2006   if [ -d /run/udev ] ; then
2007     einfo "Setting up bind-mount /run/udev"
2008     mkdir -p "${MNTPOINT}"/run/udev
2009     mount --bind /run/udev "${MNTPOINT}"/run/udev
2010   fi
2011 }
2012 # }}}
2013
2014 # execute all scripts in /etc/debootstrap/pre-scripts/ {{{
2015 execute_pre_scripts() {
2016   # make sure hostname is set even before chroot-script get executed
2017   echo "$HOSTNAME" > "$MNTPOINT"/etc/hostname
2018
2019   # make sure we have $MNTPOINT available for our scripts
2020   export MNTPOINT
2021
2022   if [ -d "$_opt_pre_scripts" ] || [ "$PRE_SCRIPTS" = 'yes' ] ; then
2023     [ -d "$_opt_pre_scripts" ] && pre_scripts="$_opt_pre_scripts" || pre_scripts="${CONFFILES}/pre-scripts/"
2024     for script in "${pre_scripts}"/* ; do
2025       if [ -x "$script" ] ; then
2026         einfo "Executing pre-script $script"
2027         "$script"
2028       fi
2029     done
2030   fi
2031 }
2032 # }}}
2033
2034 # execute all scripts in /etc/debootstrap/post-scripts/ {{{
2035 execute_post_scripts() {
2036   # make sure we have $MNTPOINT and HOSTNAME available for our scripts
2037   export MNTPOINT
2038   export TARGET_HOSTNAME=$HOSTNAME
2039
2040   if [ -d "$_opt_scripts" ] || [ "$SCRIPTS" = 'yes' ] ; then
2041     # legacy support for /etc/debootstrap/scripts/
2042     [ -d "$_opt_scripts" ] && post_scripts="$_opt_scripts" || post_scripts="${CONFFILES}/scripts/"
2043     ewarn "Deprecation NOTE: --scripts/SCRIPTS are deprecated, please switch to --post-scripts/POST_SCRIPTS instead."
2044   elif [ -d "$_opt_post_scripts" ] || [ "$POST_SCRIPTS" = 'yes' ] ; then
2045     [ -d "$_opt_post_scripts" ] && post_scripts="$_opt_post_scripts" || post_scripts="${CONFFILES}/post-scripts/"
2046   fi
2047
2048   if [ -n "$post_scripts" ] ; then
2049     for script in "${post_scripts}"/* ; do
2050       if [ -x "$script" ] ; then
2051         einfo "Executing post-script $script"
2052         "$script"
2053       fi
2054     done
2055   fi
2056 }
2057 # }}}
2058
2059 # execute chroot-script {{{
2060 chrootscript() {
2061   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
2062     mount_target
2063   fi
2064
2065   if ! [ -x "$MNTPOINT/bin/chroot-script" ] ; then
2066     eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
2067     eend 1
2068   else
2069     einfo "Executing chroot-script now"
2070     mount -t devtmpfs udev "${MNTPOINT}"/dev
2071     mount -t devpts devpts "${MNTPOINT}"/dev/pts
2072     if [ "$DEBUG" = "true" ] ; then
2073       chroot "$MNTPOINT" /bin/bash -x /bin/chroot-script
2074     else
2075       chroot "$MNTPOINT" /bin/chroot-script
2076     fi
2077     try_umount 3 "$MNTPOINT"/dev/pts
2078     try_umount 3 "$MNTPOINT"/dev
2079   fi
2080
2081   # finally get rid of chroot-script again, there's no good reason to
2082   # keep it on the installed system
2083   if grep -q GRML_CHROOT_SCRIPT_MARKER "${MNTPOINT}/bin/chroot-script" ; then
2084     einfo "Removing chroot-script again"
2085     rm -f "${MNTPOINT}/bin/chroot-script"
2086   else
2087     einfo "Keeping chroot-script as string GRML_CHROOT_SCRIPT_MARKER could not be found"
2088   fi
2089 }
2090 # }}}
2091
2092 # unmount $MNTPOINT {{{
2093 umount_chroot() {
2094
2095   # display installation notes:
2096   if [ -n "$INSTALL_NOTES" ] ; then
2097      [ -r "${MNTPOINT}/${INSTALL_NOTES}" ] && cat "${MNTPOINT}/${INSTALL_NOTES}"
2098   fi
2099
2100   if [ -n "$ISODIR" ] ; then
2101      einfo "Unmount $MNTPOINT/$ISODIR"
2102      try_umount 3 "$MNTPOINT/$ISODIR"
2103   fi
2104
2105   try_umount 3 "${MNTPOINT}"/run/udev
2106
2107   if [ -n "$PARTITION" ] ; then
2108      try_umount 3 "$MNTPOINT"
2109   fi
2110 }
2111 # }}}
2112
2113 # execute filesystem check {{{
2114 fscktool() {
2115  if [ -n "$VIRTUAL" ] ; then
2116    einfo "Skipping filesystem check because we deploy a virtual machine."
2117    return 0
2118  fi
2119
2120  if [ "$FSCK" = 'yes' ] ; then
2121    [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
2122    einfo "Checking filesystem on $TARGET using $FSCKTOOL"
2123    "$FSCKTOOL" "$TARGET"
2124  fi
2125 }
2126 # }}}
2127
2128 # get rid of grml-debootstrap config files {{{
2129 remove_configs() {
2130   if [ "$REMOVE_CONFIGS" != "yes" ] ; then
2131     return 0
2132   fi
2133
2134   if ! mountpoint "${MNTPOINT}" >/dev/null 2>&1 ; then
2135     ewarn "Target ${MNTPOINT} doesn't seem to be mounted, can't remove configuration files."
2136     return 0
2137   fi
2138
2139   einfo "Removing configuration files from installed system as requested via --remove-configs / REMOVE_CONFIGS."
2140   rm -rf "${MNTPOINT}"/etc/debootstrap/
2141 }
2142 # }}}
2143
2144 # now execute all the functions {{{
2145 for i in format_efi_partition prepare_vm mkfs tunefs \
2146          mount_target mountpoint_to_blockdevice debootstrap_system \
2147          preparechroot execute_pre_scripts chrootscript execute_post_scripts \
2148          remove_configs umount_chroot grub_install umount_target fscktool ; do
2149     if stage "${i}" ; then
2150       "$i"
2151       stage "${i}" 'done'
2152       rm -f "${STAGES}/${i}"
2153     fi
2154 done
2155
2156 cleanup
2157 # }}}
2158
2159 # end dialog of autoinstallation {{{
2160 if [ -n "$AUTOINSTALL" ] ; then
2161    if dialog --title "${PN}" --pause "Finished execution of ${PN}.
2162 Automatically rebooting in 10 seconds.
2163
2164 Choose Cancel to skip rebooting." 10 60 10 ; then
2165      noeject noprompt reboot
2166   fi
2167 else
2168    einfo "Finished execution of ${PN}. Enjoy your Debian system."
2169 fi
2170 # }}}
2171
2172 ## END OF FILE #################################################################
2173 # vim: ai tw=100 expandtab foldmethod=marker shiftwidth=2